#include <X11/Intrinsic.h>
#include <X11/IntrinsicP.h>
#include <X11/StringDefs.h>
#include <X11/CoreP.h>
#include <X11/Wc/WcCreate.h>
#include <Xm/Xm.h>

#ifdef _NO_PROTO
static Boolean CvtStringToWidget(dpy, args, numArgs, from, to, data)
Display *dpy; XrmValuePtr args; 
	Cardinal *numArgs; XrmValuePtr from; XrmValuePtr to; XtPointer *data;
#else
static Boolean CvtStringToWidget(Display *dpy, XrmValuePtr args, 
	Cardinal *numArgs, XrmValuePtr from, XrmValuePtr to, XtPointer *data)
#endif
{
    Widget self;
    Boolean badConvert;
    static Widget w;

    if (*numArgs != 1)
    {
	XtAppErrorMsg(XtDisplayToApplicationContext(dpy),
		"cvtStringToWidget", "wrongParameters",
		"XtToolkitError",
		"StringToWidget conversion needs self arg",
		(String *)NULL, (Cardinal *)NULL);
    }

    self = *(Widget *)args[0].addr;

    w = WcFullNameToWidget(self, (String)from->addr);
    badConvert = (w == NULL);

    if (badConvert)
	XtDisplayStringConversionWarning(dpy, from->addr, "Widget");
    else
    {
	if (to->addr == NULL)
	    to->addr = (XtPointer)&w;
	else if (to->size < sizeof(Widget))
	    badConvert = True;
	else
	    *(Widget *)to->addr = w;
	to->size = sizeof(Widget);
    }
    return(!badConvert);
}

static XtConvertArgRec selfConvertArgs[] = {
    {XtBaseOffset, (XtPointer)XtOffsetOf(WidgetRec, core.self), 
	sizeof(Widget)},
};

#ifdef _NO_PROTO
void installConverters(app)
XtAppContext app;
#else
void installConverters(XtAppContext app)
#endif
{
    XtSetTypeConverter(XtRString, XtRWidget, CvtStringToWidget,
	selfConvertArgs, XtNumber(selfConvertArgs), XtCacheNone, NULL);

    /* Motif is screwed up with what it thinks is a window */
    XtSetTypeConverter(XtRString, XmRWindow, CvtStringToWidget,
	selfConvertArgs, XtNumber(selfConvertArgs), XtCacheNone, NULL);

    XtSetTypeConverter(XtRString, XmRMenuWidget, CvtStringToWidget,
	selfConvertArgs, XtNumber(selfConvertArgs), XtCacheNone, NULL);
}
