#include "xtxpm.h"

typedef void (*ButtonFunction)();

typedef struct 
{
	Widget	shell;			/* main shell */
	Widget	pixarea;		/* drawing area for pixmap view */
	Widget	workarea;		/* drawing area for large view */
	Widget	workScrollWin;		/* work area scrolled window */
	Widget	textEntry;		/* text entry widget */
	Widget	messageArea;		/* message area */
	String	enteredText;		/* the text that was entered! */
	int	workWinX, workWinY;	/* position of work window */
	int	workWinW, workWinH;	/* size of work window */
	int	workObscured;		/* is work window obscured */
	int	scrollInProgress;	/* timeout added */
	int	scrollDirection;	/* how to scroll */
	Widget	clipWidget;		/* clip window widget */
	int	clipWinW, clipWinH;	/* clip window size */
	int	pw, ph;			/* pixmap width and height */
	Pixmap	pixmap;			/* actual pixmap */
	Pixmap	workpixmap;		/* work pixmap */
	Pixmap	clipboardPixmap;	/* clipboard pixmap */
	long	clipID;			/* clipboard item ID */
	int	dataID;			/* clipboard data ID */
	XImage	*image;			/* local copy of pixmap */
	XImage	*workimage;		/* local copy of work pixmap */
	XImage	*undoimage;		/* last saved copy */
	XImage	*snapshotimage;		/* last saved snapshot */
	XImage	*bitmapimage;		/* bitmap source */
	XImage	*textimage;		/* text source */
	int	bitw, bith;		/* bitmap size */
	int	txtw, txth;		/* text size */
	XpmAttributes	info;		/* x pixmap info structure */
	GC	gc;			/* copy GC */
	GC	workgc;			/* work pixmap GC */
	int	scale;			/* pixel multiplier scale */
	Pixel	workbg, workfg;		/* work area background */
	int	lastx, lasty;		/* last pointer processed */
	int	basex, basey;		/* base plant point */
	int	fg;			/* current draw pixel value */
	int	fillToBoundary;		/* fill to boundaries */
	int	opaquePaste;		/* opaque paste (draw 0 pixels too?) */
	XImage	*pasteImage;		/* paste temp image */
	char	*pixfile;		/* pixmap file name */

	ButtonFunction	buttonPressFunction;
	ButtonFunction	buttonReleaseFunction;
	ButtonFunction	buttonMotionFunction;
} Editor, *EditorPtr;
