/*
 * Xt utility routines
 *
 */

#include <X11/Intrinsic.h>
#include <X11/xpm.h>

Status XLoadWidgetPixmap(wid, filename, pixmapResource, backgroundResource)
Widget	wid;
String	filename;
String	pixmapResource;
String	backgroundResource;
{
    Screen	*screen;

    screen = XtScreenOfObject(wid);

    return(XLoadExplicitWidgetPixmap(wid, 
	RootWindowOfScreen(screen), DefaultVisualOfScreen(screen),
	DefaultDepthOfScreen(screen), DefaultColormapOfScreen(screen),
	filename, pixmapResource, backgroundResource));
}

Status XLoadExplicitWidgetPixmap(wid, win, vis, depth, cmap, 
	filename, pixmapResource, backgroundResource)
Widget		wid;
Window		win;
Visual		*vis;
int		depth;
Colormap	cmap;
String		filename;
String		pixmapResource;
String		backgroundResource;
{
    Display *dpy = XtDisplayOfObject(wid);
    Pixmap pixmap;
    unsigned long *pixels;
    unsigned int dummyw, dummyh, dummy;
    ColorSymbol cs;
    Status status;
    Arg onlyarg;
    Pixel bg;
    XpmAttributes att;

    XtSetArg(onlyarg, backgroundResource, &bg);
    XtGetValues(wid, &onlyarg, 1);

    cs.name = "background";
    cs.pixel = bg;
    cs.value = NULL;

    att.visual = vis;
    att.colormap = cmap;
    att.depth = depth;
    att.colorsymbols = &cs;
    att.numsymbols = 1;
    att.valuemask = XpmVisual | XpmColormap | XpmDepth | XpmColorSymbols;

    status = XpmReadFileToPixmap(dpy, win, filename, &pixmap,
		    NULL, &att);

    if (status != PixmapSuccess)
	return BadPixmap;

    XtSetArg(onlyarg, pixmapResource, pixmap);
    XtSetValues(wid, &onlyarg, 1);
    return Success;
}
