/*
 * XPM include into Xt applications
 *
 * Link with /usr/lib/libXpm.a (-lXpm)
 *
 * Status XLoadWidgetPixmap(widget, filename,
 *			pixmapResource, backgroundResource)
 *	This functions loads the specified pixmap resource with the 
 *	XPM file specified.  The symbolic color name "background" (if any)
 *	will be set to the "backgroundResource" color.  This is a 
 *	wrapper function to XLoadExplicitWidgetPixmap() that passes
 *	the root window, default visual, default depth, and default colormap
 *	from the widget's screen field.
 *
 *      NOTE:
 *	The window parameter to XLoadExplicitWidgetPixmap() is only used 
 *	for the XCreatePixmap call.  It is important that this window be
 *	realized!  The root window is usually sufficient.
 *
 * Status XLoadExplicitWidgetPixmap(Widget wid, Window win,
 *		Visual *vis, int depth, Colormap cmap, 
 *		String filename, String pixmapResource,
 *		String backgroundResource);
 *
 *	This function allows specific parameter to be used for the pixmap
 *	creation.  A common use of this function is when the widget
 *	does not use the default colormap.  XloadWidgetPixmap() call this.
 *	
 */
#include <X11/xpm.h>
#ifdef UNUSED
#ifdef XPE
#include <xpmP.h>
#else
#include <X11/xpmP.h>
#endif
#endif

#if __STDC__ || defined(__cplusplus) || defined(c_plusplus) 

#if defined(__cplusplus) || defined(c_plusplus)
extern "C" {
#endif

Status XLoadWidgetPixmap(Widget wid, String filename,
	String pixmapResource, String backgroundResource);

Status XLoadExplicitWidgetPixmap(Widget wid, Window win,
	Visual *vis, int depth, Colormap cmap, 
	String filename, String pixmapResource, String backgroundResource);

#if defined(__cplusplus) || defined(c_plusplus)
}
#endif

#else

Status XLoadWidgetPixmap();
Status XLoadExplicitWidgetPixmap();

#endif


